﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using Infragistics.Web.UI.GridControls;
using System.ComponentModel;

namespace WebApplication1
{
    public partial class Default : System.Web.UI.Page
    {

        protected void Page_Load(object sender, EventArgs e)
        {

            System.Data.DataTable _DataTableTest = new System.Data.DataTable();
            _DataTableTest.Columns.Add(new System.Data.DataColumn("Column01", Type.GetType("System.String")));
            _DataTableTest.Columns.Add(new System.Data.DataColumn("Column02", Type.GetType("System.String")));
            _DataTableTest.Columns.Add(new System.Data.DataColumn("Button", Type.GetType("System.String")));
            _DataTableTest.Rows.Add("Row1", "Row1", "");
            _DataTableTest.Rows.Add("Row2", "Row2", "");

            this.WebDataGrid_Test.InitializeRow -= new Infragistics.Web.UI.GridControls.InitializeRowEventHandler(WebDataGrid_Test_InitializeRow);
            this.WebDataGrid_Test.InitializeRow += new Infragistics.Web.UI.GridControls.InitializeRowEventHandler(WebDataGrid_Test_InitializeRow);
            this.WebDataGrid_Test.ItemCommand += new ItemCommandEventHandler(WebDataGrid_Test_ItemCommand);
            if (!IsPostBack)
            {
                
                TemplateDataField tf = new TemplateDataField();
                tf.Key = "Button";

                tf.Header.Text = "Button";
                this.WebDataGrid_Test.Columns.Add(tf);
            }
                TemplateDataField templateColumn1 = (TemplateDataField)this.WebDataGrid_Test.Columns["Button"];

                templateColumn1.ItemTemplate = new ActionButtons();
            

            this.WebDataGrid_Test.DataSource = _DataTableTest;
            this.WebDataGrid_Test.DataBind();

        }

        void WebDataGrid_Test_ItemCommand(object sender, HandleCommandEventArgs e)
        {
            var _rowIndex = e.CommandArgument;
            //throw new NotImplementedException();
        }

        protected override void OnInit(EventArgs e)
        {
            base.OnInit(e);
            ActionButtons _ActionButtons = new ActionButtons();
            Infragistics.Web.UI.ItemTemplate _ItemTemplate = new Infragistics.Web.UI.ItemTemplate();
            _ItemTemplate.Template = _ActionButtons;
            _ItemTemplate.TemplateID = "ActionButtons";
            this.WebDataGrid_Test.Templates.Add(_ItemTemplate);

        }

        private void WebDataGrid_Test_InitializeRow(object sender, Infragistics.Web.UI.GridControls.RowEventArgs e)
        {
            e.Row.Items[0].Column.Hidden = false;
            e.Row.Items[1].Column.Hidden = false;
          // e.Row.Items[2].TemplateId = "ActionButtons";
            e.Row.Items[2].Column.Width = 100;
            e.Row.Items[3].Column.Hidden = true;
            Button btn = (Button)e.Row.Items[0].FindControl("_Button_Cancel_ID");
            btn.CommandArgument = e.Row.Index.ToString();
            btn.CommandName = "Cancel";
        }

        protected void WebDataGrid_Test_Load(object sender, EventArgs e)
        {

        }
    }

    class ActionButtons : System.Web.UI.ITemplate
    {

        public void InstantiateIn(System.Web.UI.Control container)
        {

            System.Web.UI.WebControls.Button _Button_Cancel = new System.Web.UI.WebControls.Button();
            _Button_Cancel.Height = 25;
            _Button_Cancel.Width = 60;
            _Button_Cancel.Text = "Cancel";
            _Button_Cancel.ID = "_Button_Cancel_ID";
            //_Button_Cancel.OnClientClick = "button_Click();";
            _Button_Cancel.Click += new System.EventHandler(button_Click);
            container.Controls.Add(_Button_Cancel);

        }

        void button_Click(object sender, EventArgs e)
        {
            string index = ((System.Web.UI.WebControls.Button)(sender)).CommandArgument;
        }


    }

}